<!DOCTYPE html>
<html lang="en">
<head>
    <!-- META -->
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <!-- TITLE -->
    <title>Homework</title>
</head>
<body>
    <script>
        let x = 6, y = 14, z = 4; // Объявляем переменные и присваиваем им значения.
        x += y - x++ * z; // Выражение, x = -4
        console.log(x); // Вывод в консоль

        /* Выражение выше является идентичным выражению:
            х = х + y - x++ * z;
            х = 6 + 14 - 6 * 4;
            х = 20 - 24;
            х = -4;
            
            В обоих выражениях х++ является постфиксный инкримент, после этого выражения х увеличивается на 1,
            но поскольку мы перезаписываем в х новое значение, то эта итерация не влияет на х.
        */

        x = 6, y = 14, z = 4; // Перезаписываем переменные, чтобы вернуть прежние значения.
        z = --x - y * 5; // Выражение, z = -65
        console.log(z);
        /* Выражение выполняется следующим образом:
            z = 5 - 14 * 5;
            z = 5 - 70;
            z = -65;
        
            В выражении присутствует префиксный декремент, мы сразу уменьшаем х, а только потом выполняем шаг.
        */

        x = 6, y = 14, z = 4;
        y /= x + 5 % z;
        console.log(y);
        /* Выражение выше является идентичным выражению:
            y = y / (x + 5 % z);
            y = 14 / (6 + 5 % 4);
            y = 14 / (6 + 1);
            y = 14 / 7;
            y = 2;
        */

        x = 6, y = 14, z = 4;
        z - x++ + y * 5; 
        x = y - x++ * z;
        console.log(x)
        /*
            // Разберём данное выражение ----->  z - x++ + y * 5;
            z - x++ + y * 5;
            4 - 6 + 14 * 5;
            -2 + 70;
            -68;

            У нас, в данном выражении присутствует постфиксный инкремент, который увеличивает х на 1 после данного шага.
            Значит сейчас у нас х = 7.

            // Разберём теперь выражение -----> x = y - x++ * z;
            x = y - x++ * z;
            x = 14 - 7 * 4;
            x = 14 - 28;
            x = -14;

            Ну и соб-но х++ в выражении выше не влияет на х, так как мы его перезаписываем.
        */
    </script>
</body> 
</html>
